<ui:composition
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:rich="http://richfaces.org/rich"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <div class="row">
            <div class="col-lg-6">
                <h:form id="filterForm" styleClass="form-horizontal">
                    <ui:decorate template="/layout/panels/_panel_filter_criteria_footer.xhtml">
                        <ui:param name="sub_title"
                                  value="#{documentManager.getDocuments().size()} documents found for this search"/>

                        <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                                       value="#{documentManager.filter.urlParameters}"/>
                        <script>
                            jq162(function () {
                                jq162('[data-toggle="popover"]').popover({html: true})
                            });
                            updateUrl("pfc:filterForm:filterUrlParameters");
                            $("#pfc\\:filterForm\\:filterUrlParameters").bind('change',
                                    function () {
                                        updateUrl("pfc:filterForm:filterUrlParameters");
                                    });


                        </script>
                        <div class="row">
                            <div class="col-md-10">
                                <div class="row">
                                    <div class="col-lg-12">
                                        <ui:include src="/filter/filter.xhtml">
                                            <ui:param name="filter" value="#{documentManager.filter}"/>
                                            <ui:param name="filterId" value="idScheme"/>
                                            <ui:param name="filterName"
                                                      value="#{messages['net.ihe.gazelle.IdScheme']}"/>
                                            <ui:param name="filterForm" value="filterForm,docs"/>
                                        </ui:include>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-lg-12">
                                        <ui:include src="/filter/filter.xhtml">
                                            <ui:param name="filter" value="#{documentManager.filter}"/>
                                            <ui:param name="filterId" value="uri"/>
                                            <ui:param name="filterName"
                                                      value="uri"/>
                                            <ui:param name="filterForm" value="filterForm,docs"/>
                                        </ui:include>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-lg-12">
                                        <ui:include src="/filter/filter.xhtml">
                                            <ui:param name="filter" value="#{documentManager.filter}"/>
                                            <ui:param name="filterId" value="name"/>
                                            <ui:param name="filterName"
                                                      value="name"/>
                                            <ui:param name="filterForm" value="filterForm,docs"/>
                                        </ui:include>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-lg-12">
                                        <ui:include src="/filter/filter.xhtml">
                                            <ui:param name="filter" value="#{documentManager.filter}"/>
                                            <ui:param name="filterId" value="revision"/>
                                            <ui:param name="filterName"
                                                      value="revisionId"/>
                                            <ui:param name="filterForm" value="filterForm,docs"/>
                                        </ui:include>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-lg-12">
                                        <ui:include src="/filter/filter.xhtml">
                                            <ui:param name="filter" value="#{documentManager.filter}"/>
                                            <ui:param name="filterId" value="provenance"/>
                                            <ui:param name="filterName"
                                                      value="resource provenance"/>
                                            <ui:param name="filterForm" value="filterForm,docs"/>
                                        </ui:include>
                                    </div>
                                </div>
                                <div class="row">
                                    <s:div styleClass="col-lg-12">
                                        <ui:decorate
                                                template="/layout/form/_form_field_horizontal_4-8.xhtml">
                                            <ui:param name="id" value="unused"/>
                                            <h:selectBooleanCheckbox id="unused"
                                                                     value="#{documentManager.filter.unusedDocument}">
                                                <a4j:ajax event="change"
                                                          render="filterForm,docs"/>
                                            </h:selectBooleanCheckbox>
                                            Unused document
                                        </ui:decorate>
                                    </s:div>
                                </div>
                                <div class="row">
                                    <s:div styleClass="col-lg-12">
                                        <ui:decorate
                                                template="/layout/form/_form_field_horizontal_4-8.xhtml">
                                            <ui:param name="id" value="duplicated"/>
                                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                                <h:selectBooleanCheckbox id="duplicated"
                                                                         value="#{documentManager.filter.duplicated}">
                                                    <a4j:ajax event="change"
                                                              render="filterForm,docs"/>
                                                </h:selectBooleanCheckbox>
                                                Duplicated document
                                            </s:decorate>
                                        </ui:decorate>
                                    </s:div>
                                </div>
                            </div>
                        </div>

                        <ui:define name="filter_buttons">
                            <a4j:commandLink
                                    title="#{messages['net.ihe.gazelle.assertion-manager.ResetFilter']}"
                                    actionListener="#{documentManager.clearFilter()}"
                                    render="filterForm,docs">
                                <span class="fa fa-times-circle"/>
                            </a4j:commandLink>
                        </ui:define>
                        <ui:define name="panel_footer">
                            <h:outputLink value="edit.seam" rendered="#{s:hasRole('admin_role')}"
                                          styleClass="gzl-btn-blue">
                                <h:outputText
                                        value="Add a document"/>
                            </h:outputLink>
                            <ui:include src="/fileCache/_clearFileCache.xhtml"/>
                        </ui:define>
                    </ui:decorate>

                </h:form>
            </div>
        </div>
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">
                Documents
            </ui:define>

            <h:form>
                <rich:dataTable rows="20" id="docs" var="document"
                                value="#{documentManager.getDocuments()}" render="ds">
                    <g:column sortBy="#{'id'}">
                        <ui:define name="header">
                            id
                        </ui:define>
                        #{document.id}
                    </g:column>
                    <g:column sortBy="#{'name'}">
                        <ui:define name="header">
                            name
                        </ui:define>
                        #{document.name}
                    </g:column>
                    <g:column sortBy="#{'uri'}">
                        <ui:define name="header">
                            url
                        </ui:define>
                        <!-- //TODO embed pdfjs to avoid this test and directly open the pdf -->
                        <h:outputLink title="#{messages['net.ihe.gazelle.assertion-manager.ViewPdfDocument']}"
                                      rendered="#{document.getIdSchemesLinked().size() > 0 and document.pointsToPdf()}"
                                      value="#{request.contextPath}/rest/testAssertion/assertion/document/open"
                                      target="spec">
                            <f:param name="idScheme"
                                     value="#{document.getIdSchemesLinked().get(0)}"/>
                            #{document.uri}
                        </h:outputLink>
                        <h:outputLink title="#{messages['net.ihe.gazelle.assertion-manager.ViewPdfDocument']}"
                                      rendered="#{document.getIdSchemesLinked().size() == 0 or not document.pointsToPdf()}"
                                      value="#{document.uri}"
                                      target="spec">
                            #{document.uri}
                        </h:outputLink>
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            documentId
                        </ui:define>
                        #{document.documentId}
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            revisionId
                        </ui:define>
                        #{document.revisionId}
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            resource provenance
                        </ui:define>
                        #{document.resourceProvenanceId}
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            Links
                        </ui:define>

                        <h:outputLink title="view assertions"
                                      value="#{request.contextPath}/assertions/index.seam">
                            <f:param name="document" value="#{document.id}"/>
                            #{document.countAssertionsLinked()}
                        </h:outputLink>
                    </g:column>
                    <g:column>
                        <ui:define name="header">
                            id schemes
                        </ui:define>
                        <ul>
                            <a4j:repeat value="#{document.getIdSchemesLinked()}" var="scheme">
                                <li>
                                    <h:outputLink title="view scheme"
                                                  value="#{request.contextPath}/assertions/index.seam">
                                        <f:param name="idScheme" value="#{scheme}"/>
                                        #{scheme}
                                    </h:outputLink>
                                </li>
                            </a4j:repeat>
                        </ul>
                    </g:column>

                    <g:column rendered="#{s:hasRole('admin_role')}">
                        <ui:define name="header">
                            action
                        </ui:define>
                        <span class="gzl-never-wrap">
                            <h:outputLink title="link document to idScheme"
                                          rendered="#{s:hasRole('admin_role')}"
                                          value="link.seam">
                                <f:param name="id" value="#{document.id}"/>
                                <span class="gzl-icon-link"/>
                            </h:outputLink>

                            <h:outputLink title="edit document"
                                          rendered="#{s:hasRole('admin_role')}"
                                          value="edit.seam">
                                <f:param name="id" value="#{document.id}"/>
                                <span class="gzl-icon-pencil"/>
                            </h:outputLink>
                            <a4j:commandLink title="#{messages['users.Delete']}"
                                             rendered="#{s:hasRole('admin_role')}"
                                             actionListener="#{documentManager.setSelectedDocument(document)}"
                                             oncomplete="jq162('#DeleteConfirmationModalPanel').modal('show');"
                                             immediate="true"
                                             render="confirmationModalPanelDecoration"
                                             execute="@this">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </span>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="docs"/>
                            <ui:param name="hideRowsSelect" value="true"/>
                            <ui:param name="maxPages" value="5"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </h:form>
        </ui:decorate>
        <h:form id="deleteDocumentForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="DeleteConfirmationModalPanel"/>
                <ui:define name="popup_title">
                    Confirm deletion of document
                </ui:define>

                <s:decorate id="confirmationModalPanelDecoration">
                    <ui:decorate template="/layout/panels/_panel.xhtml">
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">Document Name</ui:define>
                            <h:outputText value="#{documentManager.getSelectedDocument().name}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">Document URL</ui:define>
                            <h:outputText value="#{documentManager.getSelectedDocument().uri}"/>
                        </s:decorate>

                        <h:panelGroup rendered="#{not empty documentManager.getSelectedDocument().getIdSchemesLinked()}">
                            <div class="alert alert-danger">
                                This document is linked to those idSchemes:
                                <ul>
                                    <a4j:repeat value="#{documentManager.getSelectedDocument().getIdSchemesLinked()}"
                                                var="scheme">
                                        <li>
                                            <h:outputLink title="view scheme"
                                                          value="#{request.contextPath}/assertions/index.seam">
                                                <f:param name="idScheme" value="#{scheme}"/>
                                                #{scheme}
                                            </h:outputLink>
                                        </li>
                                    </a4j:repeat>
                                </ul>
                                By deleting the document, idScheme's assertions unlinked from this document, therefore
                                wont be linked to any document.
                            </div>
                        </h:panelGroup>
                        <h:panelGroup rendered="#{empty documentManager.getSelectedDocument().getIdSchemesLinked()}">
                            <div class="alert alert-success">
                                This document is linked to no idSchemes. it's safe to delete it.
                            </div>
                        </h:panelGroup>
                    </ui:decorate>
                </s:decorate>

                <ui:define name="popup_footer">
                    <h:commandButton value="#{messages['users.Delete']}" action="#{documentManager.delete()}"
                                     styleClass="gzl-btn-red" render="docs"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>
                    <h:commandButton value="#{messages['users.Cancel']}"
                                     styleClass="gzl-btn"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>